/**
 * {}
 * @author yutent<yutent.io@gmail.com>
 * @date 2023/07/20 14:19:13
 */

import 'es.shim'
import { html, css, Component } from 'wkit'
import { createApp } from 'wkitd'

import 'ui/icon/index.js'
import 'ui/scroll/index.js'
import 'ui/layer/index.js'
import 'ui/space/index.js'
import 'ui/form/input.js'
import 'ui/form/switch.js'
import 'ui/form/button.js'
import 'ui/form/link.js'

import router from './router.js'
import store from './store.js'

import '../components/sidebar.js'

import { noop } from './utils/index.js'

createApp({
  data: {
    input: '',
    img: '',
    content: ''
  },
  styles: [
    css`
      :host {
        display: flex;
        width: 100%;
        height: 100vh;
      }

      router-view {
        flex: 1;
        height: 100;
      }
    `
  ],
  methods: {
    quit() {
      native.quit()
    }
  },
  render() {
    return html`
      <wc-sidebar></wc-sidebar>
      <router-view></router-view>
      <wc-layer ref="context" left="100px" top="0" radius="0">
        <ul class="context-menu" @click=${this.confirmAction}>
          <li class="item" data-act="del">删除域名</li>
          <li class="item" data-act="edit">修改域名</li>
        </ul>
      </wc-layer>
    `
  }
})
  .use(router)
  .use(store)
  .mount()
