/**
 * {}
 * @author yutent<yutent.io@gmail.com>
 * @date 2023/08/08 18:19:17
 */
import { html, css, Component, classMap, nextTick, outsideClick } from 'wkit'

// import '../components/records.js'

import { noop } from '../utils/index.js'

class Home extends Component {
  static props = {}

  static styles = [
    css`
      :host {
        display: block;
        width: 100%;
        height: 100%;
        color: var(--color-dark-1);
        background: #fff;
      }
      .visible {
        display: block;
      }

      ul li {
        list-style: none;
      }

      .noselect {
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        user-select: none;
      }
    `,

    css`
      .main {
        display: flex;
        flex-direction: column;
        padding: 16px;
      }
      .main .toolbar {
        display: flex;
        align-items: center;
        justify-content: space-between;
        height: 48px;
        border-bottom: 1px solid var(--color-plain-3);
      }
      .main .list {
        overflow: hidden;
        flex: 1;
      }
    `,

    css`
      .context-menu {
        display: flex;
        flex-direction: column;
        width: 100px;
        padding: 5px 0;
        background: #fff;
      }

      .context-menu .item {
        height: 30px;
        line-height: 30px;
        padding: 0 15px;
        cursor: pointer;
      }

      .context-menu .item :hover {
        background: #f2f5fc;
      }
    `
  ]

  async mounted() {
    // outsideClick(this.$refs.context, _ => this.$refs.context.close())
  }

  showMenu(ev) {
    this.$refs.context.close()
    var { pageX, pageY } = ev
    if (pageY + 70 > 600) {
      pageY -= 70
    }

    var elem = ev.target

    if (elem.tagName !== 'LI') {
      elem = elem.parentNode
    }
    this.editDomain = elem.dataset.name
    setTimeout(_ => {
      this.$refs.context.moveTo({ left: pageX + 'px', top: pageY + 'px' })
      this.$refs.context.show()
    })
  }

  confirmAction(ev) {
    this.$refs.context.close()
    if (ev.target.tagName === 'LI') {
      let act = ev.target.dataset.act
      if (act === 'del') {
      } else if (act === 'edit') {
      }
    }
  }

  save() {
    let { HOST_DATA, activeDomain, records } = this.$store
    if (activeDomain) {
      HOST_DATA[activeDomain] = records.filter(it => it.record && it.value)
    }
    saveHosts(HOST_DATA)
    layer.toast('保存成功', 'success')
  }

  render() {
    return html`
      <main class="main noselect">
        <header class="toolbar">
          <wc-input round></wc-input>
        </header>
      </main>
    `
  }
}

Home.reg('containers')
